'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global IntersectionObserver */

var Observed = function (_Component) {
    _inherits(Observed, _Component);

    function Observed() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Observed);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Observed.__proto__ || Object.getPrototypeOf(Observed)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            isInView: false
        }, _this.mapRef = function (ref) {
            _this.el = ref;
        }, _this.handleIntersection = function (entries, observer) {
            var _this$props = _this.props,
                intersectionRatio = _this$props.intersectionRatio,
                once = _this$props.once;


            entries.forEach(function (entry) {
                var isInView = entry.intersectionRatio >= intersectionRatio;

                if (isInView !== _this.state.isInView) {
                    // update if we've transitioned to a different state
                    _this.setState(function () {
                        return { isInView: isInView };
                    });
                }

                if (isInView && once) {
                    // if once is true, disconnect after the element is in view.
                    _this.disconnectObserver();
                }
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Observed, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.createObserver();
            this.observe();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.disconnectObserver();
        }
    }, {
        key: 'createObserver',
        value: function createObserver() {
            this.checkForObserver();

            this.observer = new IntersectionObserver(this.handleIntersection, this.props.options);
        }
    }, {
        key: 'checkForObserver',
        value: function checkForObserver() {
            var hasObserver = 'IntersectionObserver' in window;
            if (!hasObserver) {
                throw new Error('Must provide an IntersectionObserver polyfill for browsers that do not yet support the technology.');
            }
        }
    }, {
        key: 'disconnectObserver',
        value: function disconnectObserver() {
            if (this.observer) {
                this.observer.disconnect();
            }
        }
    }, {
        key: 'observe',
        value: function observe() {
            if (!this.el) {
                throw new Error('Must provide a ref to the DOM element to be observed.');
            }

            var el = this.el;
            this.observer.observe(el);
        }
    }, {
        key: 'render',
        value: function render() {
            var isInView = this.state.isInView;
            var mapRef = this.mapRef;


            return this.props.children({ isInView: isInView, mapRef: mapRef });
        }
    }]);

    return Observed;
}(_react.Component);

Observed.defaultProps = {
    intersectionRatio: 1.0, // intersect ratio that the element is considered "in view"
    once: false, // remove after the el has intersected the view
    options: {
        root: null, // document.querySelector('#scrollArea')
        rootMargin: '0px', // margin around observed element
        threshold: [1.0] // callback is invoked when the intersection ratio reaches each threshold
    }
};
Observed.propTypes = {
    children: _propTypes2.default.func.isRequired,
    intersectionRatio: _propTypes2.default.number.isRequired,
    once: _propTypes2.default.bool.isRequired,
    options: _propTypes2.default.shape({
        root: _propTypes2.default.node,
        rootMargin: _propTypes2.default.string.isRequired,
        threshold: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.number])
    })
};
exports.default = Observed;